#!/usr/bin/python

xmlns="http://asp.mexmat.net/xmlns/ssx"

__ssx_xml_header = """<?xml version='1.0' encoding='utf-8'?>"""
__ssx_test_string = """
<ssx:body xmlns="http://www.w3.org/1999/xhtml" xmlns:ssx="%s">
	<ssx:title>Тестовый документ</ssx:title>
	<ssx:css href='test.css'/>
	<ssx:error><p>какая-то ошибка</p></ssx:error>
	<ssx:meta>метаинфа</ssx:meta>
</ssx:body>
""" % xmlns

class SSXRedirect(Exception):
	def __init__(self, url):
		self.url = url 

class SSXML:
	SSXRedirect = SSXRedirect
	def __init__(self):
		self.body = "<?xml version='1.0' encoding='utf8'?>\n"
		self.stack = []
	def push(self, tag, attr=""):
		self.body += "<"+tag+" "+attr+">"
		self.stack.append(tag)
	def pop(self, tag=""):
		while len(self.stack):
			tmp = self.stack.pop()
			self.body += "</"+tmp+">\n"
			if (tag == "" or tag == tmp):
				break
	def data(self, data):
		self.body += data;
	def text(self):
		if len(self.stack):
			self.pop(self.stack[0])
		return self.body
	def xml(self):
		import libxml2
		return libxml2.parseDoc(self.text())

	__str__ = text

class SSXSLT:
	SSXRedirect = SSXRedirect
	import libxml2
	import libxslt

	def __init__(self, path):
		self.path = path 
		xsltdoc = self.libxml2.parseFile(path)
		if not xsltdoc:
			raise RuntimeError("Unable to parse XML from %s" % path)
		self.__xslt = self.libxslt.parseStylesheetDoc(xsltdoc)
		if not self.__xslt:
			raise RuntimeError("Unable to load XSLT from %s" % path)
	def __del__(self):
		if self.__xslt:
			self.__xslt.freeStylesheet()
		if self.__xml:
			self.__xml.freeDoc()
		if self.__result:
			self.__result.freeDoc()
	def xslt(self, xml):
		self.__xml = self.libxml2.parseDoc(xml)
		self.__result = self.__xslt.applyStylesheet(self.__xml, None)
		return self.__xslt.saveResultToString(self.__result)
